#include<stdio.h>
#include<stdlib.h>
#include<math.h>

double Variance(double *x , int num){
	double sum_x  = 0.0;
	double sum_xx = 0.0;
	int i;
	for(i=0;i<num;i++){
		sum_x  += x[i];
		sum_xx += x[i]*x[i];
	}
	return (sum_xx/num - pow(sum_x/num, 2));
}

double Covariance(double *x , double *y , int num){
	double sum_x  = 0.0;
	double sum_y  = 0.0;
	double sum_xy = 0.0;
	int i;
	for(i=0;i<num;i++){
		sum_x  += x[i];
		sum_y  += y[i];
		sum_xy += x[i] * y[i];
	}
	return ( sum_xy /num - (sum_x/num)*(sum_y/num) );
}

double Correlation( double *x , double *y , int num){
	double r;
	r = Covariance(x,y,num)/sqrt( Variance(x,num) * Variance(y,num));
	
	return r;
}

#define Data_num	365
#define size		9

int main(void){
	int i,j,k;
	double **x;
	x = (double **)calloc( size , sizeof(double*));
	for(i=0;i<size;i++){
		x[i] = (double *) calloc( Data_num , sizeof(double) );
	}
	
	FILE *fp,*fpw,*fpt;
	fp = fopen("data.dat","r");
	fpw = fopen("problem4_3_1.dat","w");
	fpt = fopen("problem4_3_1_t.dat","w");
	
	for(i=0;i<Data_num;i++){
		fscanf(fp,"%lf	%lf	%lf	%lf	%lf	%lf	%lf	%lf	%lf",&x[0][i],&x[1][i],&x[2][i],&x[3][i],&x[4][i],&x[5][i],&x[6][i],&x[7][i],&x[8][i]);
	}
	
	double r[size][size];
	double *tmp1,*tmp2;
	tmp1 = (double *)calloc( Data_num, sizeof(double) );
	tmp2 = (double *)calloc( Data_num, sizeof(double) );
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			for(k=0;k<Data_num;k++){
				tmp1[k] = x[i][k];
				tmp2[k] = x[j][k];
			}
			r[i][j] =Correlation(tmp1,tmp2,Data_num);
			if( j != size -1 )	fprintf(fpw,"%f	", r[i][j] );
			else				fprintf(fpw,"%f", r[i][j] );
		}
		fprintf(fpw,"\n");
	}
	
	double t;
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			t = sqrt( pow(r[i][j],2) * (Data_num-2) / (1 - pow(r[i][j],2) ) );
			fprintf(fpt,"%.6f	", t );
		}
		fprintf(fpt,"\n");
	}
	
	
	fclose(fp);
	fclose(fpw);
	fclose(fpt);
	for(i=0;i<size;i++) free(x[i]);
	free(tmp1);
	free(tmp2);
	
	return 0;
}

